GroundAssault = Class:derive("GroundAssault")
GroundAssault.Settings = {
  unitLifeSpan = 2700 --45
}
GroundAssault.Settings.EnemyUnits = {
  T90 = "MBT T-90 Ground Assault",
  T80U = "MBT T-80U Ground Assault",
  BTR80 = "BTR-80 Ground Assault",
  MobileAAA = "AAA ZU-23 Ground Assault",
  SA13 = "SAM SA-13 Ground Assault",
  Outpost = "Outpost Ground Assault",
  Watchtower = "Watch Tower Ground Assault",
  RusSoldier = "Rus Soldier Ground Assault",
  Transport1 = "Transport Ural Ground Assault",
  Transport2 = "Transport KAMAZ Ground Assault"
  
}
GroundAssault.Zones = {
  "Attack_Helo_1",
  "Attack_Helo_2",
  "Attack_Helo_3",
  "Attack_Helo_4",
  "Attack_Helo_5",
  "Attack_Helo_6",
  "Attack_Helo_7",
  "Attack_Helo_8",
  "Attack_Helo_9",
  "Attack_Helo_10",
  "Attack_Helo_11",
  "Attack_Helo_12",
  "Attack_Helo_13",
  "Attack_Helo_14",
  "Attack_Helo_15",
  "Attack_Helo_16",
  "Attack_Helo_17",
  "Attack_Helo_18",
  "Attack_Helo_19",
  "Attack_Helo_20",
  
} 

function GroundAssault:New(playerGroup,_numPlayers)

  local numPlayers = _numPlayers
  local PlayerGroup = playerGroup
  local PlayerGroupName = PlayerGroup:GetPlayerName()
  --check if already assigned an Assignment
  if TheFrat.GetMooseClientStateData(PlayerGroup,"hasAssignment") == true then
    TheFrat.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
    MESSAGE:New("You have already been assigned a Task. Please review your briefing from F10 Menu. Complete you current task before selecting a new one.",15):ToGroup(PlayerGroup)
  else
  
    if TheFrat.tablelength(GroundAssault.Zones) >= 1 then
      --lets set some vars
      local EnemyGroupSet = SET_GROUP:New()
      local inAirSpace = false --within FARP Hollywood Airspace
      local firstTakeoff = false
      local inTargetArea = false
      local targetsDestroyed = false 
      local isOutPost = math.floor((math.random() * 4)-2) --if 1 then make target area an outpost
      local missionComplete = false
      local killCount = 0
      local Task_ID = TheFrat.RandomNumber()
      local PlayerType = PlayerGroup:GetTypeName()
      local markerGroup = false --group used to create marker
      
      --moose client hasAssigment to true
      TheFrat.SetMooseClientStateData(PlayerGroup,"hasAssignment", true)
      
      --select random attack zone
      local zoneName = TheFrat.randomchoice(GroundAssault.Zones)
      local Zone = ZONE:New(zoneName)
      TheFrat.removeTableEntry(GroundAssault.Zones,zoneName)
      local ZoneVec3Point = POINT_VEC3:NewFromVec3( Zone:GetVec3() )
      local ZoneRadius = ZONE_RADIUS:New( zoneName.."_"..TheFrat.RandomVariable(3), Zone:GetVec2(), 3704 )--about 2 miles
      
      --Spawn Random Enemy Units in route to enemy target zone when not in allied zone
      local noEnemyThreatZones = Settings.NoThreatsZones --table
      table.insert(noEnemyThreatZones, ZoneRadius)
     
      --Spawn Enemy Targets
        local T90_num = 0
        local T80U_num = 0
        local BTR80_num = 0
        local MobileAAA_num = 0
        local SA13_num = 0
        local RusSoldiers_num = 0
        local RusTransport1_num = 0
        local RusTransport2_num = 0
         
      if PlayerType == "Ka-50" then
          --KA 50s
          if numPlayers == 1 then
             T90_num = math.random(2,3)
             T80U_num = math.random(2,3)
             BTR80_num = math.random(2,3)
             MobileAAA_num = math.random(0,2)
             SA13_num = math.floor((math.random() * 4)-2)
          elseif numPlayers == 2 then
            T90_num = math.random(3,4)
            T80U_num = math.random(3,4)
            BTR80_num = math.random(3,4)
            MobileAAA_num = math.random(1,2)
            SA13_num = math.floor((math.random() * 4)-2)
          elseif numPlayers == 3 then
            T90_num = 5
            T80U_num = 5
            BTR80_num = 5
            MobileAAA_num = 3
            SA13_num = math.floor((math.random() * 2)-2)
          else
            --4 players
            T90_num = 7
            T80U_num = 7
            BTR80_num = 3
            MobileAAA_num = 4
            SA13_num = math.floor((math.random() * 2)-2)
          end
         
         
      elseif PlayerType == "UH-1H" or PlayerType == "Mi-8MT" then
        --UH Hueys
          if numPlayers == 1 then
            BTR80_num = 1
            RusSoldiers_num = math.random(3,5)
            RusTransport1_num = math.random(1,2)
            RusTransport2_num = math.random(1,2)
          elseif numPlayers == 2 then
            BTR80_num = 2
            RusSoldiers_num = math.random(5,8)
            RusTransport1_num = math.random(2,3)
            RusTransport2_num = math.random(1,2)
          elseif numPlayers == 3 then
            BTR80_num = math.random(2,3)
            RusSoldiers_num = 10
            RusTransport1_num = math.random(2,3)
            RusTransport2_num = math.random(2,4)
          else
            BTR80_num = math.random(3,5)
            RusSoldiers_num = 15
            RusTransport1_num = math.random(2,4)
            RusTransport2_num = math.random(3,4)
          end
      else
        --gazell offer small num of targets
        if numPlayers == 1 then
           T90_num = math.random(1,2)
           T80U_num = math.random(0,2)
           BTR80_num = math.random(1,1)
           MobileAAA_num = 1
           SA13_num = math.floor((math.random() * 4)-2)
        elseif numPlayers == 2 then
          T90_num = 2
           T80U_num = 2
           BTR80_num = 2
           MobileAAA_num = 2
           SA13_num = math.floor((math.random() * 4)-2)
        elseif numPlayers == 3 then
          T90_num = 3
           T80U_num = 3
           BTR80_num = 3
           MobileAAA_num = 3
           SA13_num = math.floor((math.random() * 2)-2)
        else
          T90_num = 4
           T80U_num = 4
           BTR80_num = 4
           MobileAAA_num = 4
           SA13_num = math.floor((math.random() * 2)-2)
        end
         
      end
 
      -- do non outpost target
     if isOutPost == 1 then
      SPAWNSTATIC:NewFromStatic( "Outpost Ground Assault", country.id.AGGRESSORS ):SpawnFromZone(Zone,0)
      SPAWNSTATIC:NewFromStatic( "Watch Tower Ground Assault", country.id.AGGRESSORS ):SpawnFromZone(Zone,0)   
     end
     
      --T90s
      for num = T90_num,1,-1
      do
        local group = GroundAssault.SpawnT90:SpawnFromVec2( ZoneVec3Point:GetVec2() )  
        EnemyGroupSet:AddGroupsByName(group)
        markerGroup = group
      end
      --T80U
      for num = T80U_num,1,-1
      do
        local group = GroundAssault.SpawnT80U:SpawnFromVec2( ZoneVec3Point:GetVec2() )  
        EnemyGroupSet:AddGroupsByName(group)
        markerGroup = group
      end
      --BTR-80
      for num = BTR80_num,1,-1
      do
        local group = GroundAssault.SpawnBTR80:SpawnFromVec2( ZoneVec3Point:GetVec2() )  
        EnemyGroupSet:AddGroupsByName(group)
        markerGroup = group
      end
      --MobileAAA
      for num = MobileAAA_num,1,-1
      do
        local group = GroundAssault.SpawnMobileAAA:SpawnFromVec2( ZoneVec3Point:GetVec2() )  
        EnemyGroupSet:AddGroupsByName(group)
        markerGroup = group
      end
      
      --SA13
      if SA13_num == 1 then
        for num = SA13_num,1,-1
        do
          local group = GroundAssault.SpawnSA13:SpawnFromVec2( ZoneVec3Point:GetVec2() )  
          EnemyGroupSet:AddGroupsByName(group)
          markerGroup = group
        end
      end
      
      --Rus Soldiers
      for num = RusSoldiers_num,1,-1
      do
        local group = GroundAssault.RusSoldier:SpawnFromVec2( ZoneVec3Point:GetVec2() )  
        EnemyGroupSet:AddGroupsByName(group)
        markerGroup = group
      end
      --Rus Transport 1
      for num = RusTransport1_num,1,-1
      do
        local group = GroundAssault.Transport1:SpawnFromVec2( ZoneVec3Point:GetVec2() )  
        EnemyGroupSet:AddGroupsByName(group)
        markerGroup = group
      end
      --Rus Transport 2
      for num = RusTransport2_num,1,-1
      do
        local group = GroundAssault.Transport2:SpawnFromVec2( ZoneVec3Point:GetVec2() )  
        EnemyGroupSet:AddGroupsByName(group)
        markerGroup = group
      end
      
      local function Objective()
        local obv = "Destroy Enemy Targets"
        if isOutPost == 1 then
          obv = "Destroy Targets at Enemy Outpost"
        end
        return obv
      end
      
       --targets
      --MESSAGE:New("Your Primary Targets :",35):ToGroup(PlayerGroup)
      local _targets = {}
      EnemyGroupSet:ForEachGroup(function(group)
      if group:IsAlive() ~= nil and group:IsAlive() == true then
        --MESSAGE:New(group:GetTypeName(),35):ToGroup(PlayerGroup)
        table.insert(_targets, tostring(group:GetTypeName()))
       end
      end)
      
      local lat, long = coord.LOtoLL(ZoneVec3Point)
      --Set Briefing Menu
      local numofTargets = TheFrat.CountGroupSet(EnemyGroupSet)     
      local brief = "Mission #: "..Task_ID.."\n"..
          "Pilot: "..PlayerGroup:GetPlayerName().."\n"..
          "Objective: "..Objective().."\n"..
          "Number of Targets : "..numofTargets.."\n"..
          "______________________\n\n".. 
          "To Target Area \n\n"..
          "BRA: "..TheFrat.GetBearingToZone(PlayerGroup:GetVec3(),Zone:GetVec3())..'\n'..
          --"LL : "..UTILS.tostringLL( lat, long, 1, false ).."\n"..
          "LL : "..UTILS.tostringLL( lat, long, 1, false ).."\n\n"..
          "Targets: \n"..
          TheFrat.table_to_string(_targets)
          --"MGRS : "..UTILS.tostringMGRS( coord.LLtoMGRS( lat, long ), _SETTINGS.MGRS_Accuracy ).."\n\n"..
          
      --CREATE Task in DB
      local lz_lat, lz_long = coord.LOtoLL(Zone:GetPointVec3())
     
           
      TheFrat.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
      MESSAGE:New(brief,35,"",true):ToGroup(PlayerGroup)
      
      --create map marker
      TheFrat.CreateMarker(markerGroup,"Mission : "..Task_ID.."\n# Players: "..numPlayers,true,2700)
     
       
      local function showBriefing()
        TheFrat.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
        MESSAGE:New(brief,35):ToGroup(PlayerGroup)
      end
      local BriefingMenu = MENU_GROUP:New( PlayerGroup, "Your Assignment" )
      local BriefingMenuCommand = MENU_GROUP_COMMAND:New( PlayerGroup, "Briefing", BriefingMenu, showBriefing , PlayerGroup )
      
      --EnemyGroup Set
      EnemyGroupSet:HandleEvent(EVENTS.Dead)
      function EnemyGroupSet:OnEventDead(EventData)
        local TargetUnit = EventData.IniUnit
        MESSAGE:New(TargetUnit:GetTypeName().." Destoryed!",3):ToGroup(PlayerGroup)
        killCount = killCount + 1
        if killCount == numofTargets and targetsDestroyed == false then
          targetsDestroyed = true
          --Task Successful
          SCHEDULER:New( nil,
            function()
              TheFrat.PlaySoundTAll("radioscratch.ogg")
              MESSAGE:New("FUCKIN A! All of your targets have been destroyed! Excellent work "..PlayerGroup:GetPlayerName().."!",16,"HQ"):ToAll()
              
              local missionMarkerText = "Mission ID: "..Task_ID.." - Strike/Attack\n"..
                                        "Pilot: "..PlayerGroup:GetPlayerName().."\n"..
                                        killCount.." ground targets destroyed!"
              TheFrat.CreateMarker(Zone,missionMarkerText,true)
              
              local MarkerText = "Mission ID: "..Task_ID.." - Strike/Attack\\n"..
                                        "Pilot: "..PlayerGroup:GetPlayerName().."\\n"..
                                        killCount.." ground targets destroyed!"
              --TheFrat.AddMarkerTable(Zone,Task_ID,MarkerText,TheFrat.GetMooseClientStateData(PlayerGroup,"ucid"))
              
            end, {},5)
          
        end
      end
      
      
      --EVENTS
      --Takeoff
      PlayerGroup:HandleEvent(EVENTS.Takeoff)
      function PlayerGroup:OnEventTakeoff(EventData)
        if firstTakeoff == false then
          firstTakeoff = true
          --Leaving Safe Zone Check
          TheFrat.LeavingZoneCheck(PlayerGroup, Settings.SafeZone,"FARP Hollywood")
        end
      end
      
      --Landing
      PlayerGroup:HandleEvent(EVENTS.Land)
      function PlayerGroup:OnEventLand(EventData)
        if TheFrat.CheckIfInSafeZone(PlayerGroup,Settings.FARPHollywood_Allied_LZs) == true and targetsDestroyed == true and missionComplete == false then
          missionComplete = true
          --Acknowledge
          SCHEDULER:New( nil,
            function()
              TheFrat.PlaySoundToGroup("info.ogg",PlayerGroup)
              PlayerGroup:Message("Mission Successful! All "..numofTargets.." targets where destroyed!",20,"HQ")
              BriefingMenu:Remove()
              TheFrat.SetMooseClientStateData(PlayerGroup,"hasAssignment", false)  
            end, {},4)
        
        end
        
        
      end
      
      --Leave Unit
      PlayerGroup:HandleEvent(EVENTS.PlayerLeaveUnit)
      function PlayerGroup:OnEventPlayerLeaveUnit(EventData)
        
        if targetsDestroyed == false then
          SCHEDULER:New( nil,
            function()
               TheFrat.DestroyGroupSet(EnemyGroupSet)
            end, {},GroundAssault.Settings.unitLifeSpan)

        end
        
        BriefingMenu:Remove()
        TheFrat.SetMooseClientStateData(PlayerGroup,"hasAssignment", false)  
      end
      
      --player dead
      PlayerGroup:HandleEvent(EVENTS.Dead)
      function PlayerGroup:OnEventDead(EventData)
        if targetsDestroyed == false then
          SCHEDULER:New( nil,
            function()
               TheFrat.DestroyGroupSet(EnemyGroupSet)
            end, {},GroundAssault.Settings.unitLifeSpan)
        end
        
        BriefingMenu:Remove()
        TheFrat.SetMooseClientStateData(PlayerGroup,"hasAssignment", false)  
      end
      
      --Crash
      PlayerGroup:HandleEvent(EVENTS.Crash)
      function PlayerGroup:OnEventCrash(EventData)

        BriefingMenu:Remove()
        TheFrat.SetMooseClientStateData(PlayerGroup,"hasAssignment", false) 
        if targetsDestroyed == false then
          SCHEDULER:New( nil,
            function()
               TheFrat.DestroyGroupSet(EnemyGroupSet)
            end, {},GroundAssault.Settings.unitLifeSpan)
        end
      end
      
      
    else
      --no avalible zones
      TheFrat.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
      MESSAGE:New("Currently no Ground Assasult Assingments at this time, please try back later.",10):ToGroup(PlayerGroup)
    end
    
  end
  
end

function GroundAssault:Menu(playerGroup)
    local PlayerGroup = playerGroup
    local _numPlayers = 1
  
    if TheFrat.ClientInTable(Settings.clientAttackTable,PlayerGroup:GetName()) then
      
      --Setup Menu Option
    local function ShowInst()
        local inst = "++ Ground Assault Instructions ++"
        TheFrat.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
        MESSAGE:New(inst,10):ToGroup(PlayerGroup)
        
      end
    
    local function GetAssignment1()
      local _numPlayers = 1
      TheFrat.PlaySoundToGroup("beep1.ogg",PlayerGroup)
      MESSAGE:New(">> Fetching Ground Assault Assigment for "..PlayerGroup:GetName().."\n# of Players: ".._numPlayers,5):ToGroup(PlayerGroup)    
      SCHEDULER:New( nil,
        function()
          TheFrat.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
          GroundAssault:New(PlayerGroup,_numPlayers)
          
        end, {},6)
    end
    local function GetAssignment2()
      local _numPlayers = 2
      TheFrat.PlaySoundToGroup("beep1.ogg",PlayerGroup)
      MESSAGE:New(">> Fetching Ground Assault Assigment for "..PlayerGroup:GetName().."\n# of Players: ".._numPlayers,5):ToGroup(PlayerGroup)    
      SCHEDULER:New( nil,
        function()
          TheFrat.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
          GroundAssault:New(PlayerGroup,_numPlayers)
        end, {},6)
    end
    local function GetAssignment3()
      local _numPlayers = 3
      TheFrat.PlaySoundToGroup("beep1.ogg",PlayerGroup)
      MESSAGE:New(">> Fetching Ground Assault Assigment for "..PlayerGroup:GetName().."\n# of Players: ".._numPlayers,5):ToGroup(PlayerGroup)    
      SCHEDULER:New( nil,
        function()
          TheFrat.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
          GroundAssault:New(PlayerGroup,_numPlayers)
        end, {},6)
    end
    local function GetAssignment4()
      local _numPlayers = 4
      TheFrat.PlaySoundToGroup("beep1.ogg",PlayerGroup)
      MESSAGE:New(">> Fetching Ground Assault Assigment for "..PlayerGroup:GetName().."\n# of Players: ".._numPlayers,5):ToGroup(PlayerGroup)    
      SCHEDULER:New( nil,
        function()
          TheFrat.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
          GroundAssault:New(PlayerGroup,_numPlayers)
        end, {},6)
    end
      
    local function SelectNumPlayers()
      
      TheFrat.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
      MESSAGE:New("For How Many Players?\nSelect using F10 Menu",30):ToGroup(PlayerGroup)
      
     local SelectMenu = MENU_GROUP:New( PlayerGroup, "Select # of Players" )
     local singlePlayerMenu = MENU_GROUP_COMMAND:New( PlayerGroup, "1 Player", SelectMenu, GetAssignment1 , PlayerGroup )--instr in CSAR class
     local twoPlayerMenu = MENU_GROUP_COMMAND:New( PlayerGroup, "2 Player", SelectMenu, GetAssignment2 , PlayerGroup )--instr in CSAR class
     local threePlayerMenu = MENU_GROUP_COMMAND:New( PlayerGroup, "3 Player", SelectMenu, GetAssignment3 , PlayerGroup )--instr in CSAR class
     local fourPlayerMenu = MENU_GROUP_COMMAND:New( PlayerGroup, "4 Player", SelectMenu, GetAssignment4 , PlayerGroup )--instr in CSAR class
     
     SCHEDULER:New( nil,
        function()
          SelectMenu:Remove()
        end, {},60)
    end
    
    local GroundAssaultMenu = MENU_GROUP:New( PlayerGroup, "Ground Assault" )
    local TIInstrustions = MENU_GROUP_COMMAND:New( PlayerGroup, "Instructions", GroundAssaultMenu, ShowInst , PlayerGroup )--instr in CSAR class
    local GetGAAssignment = MENU_GROUP_COMMAND:New( PlayerGroup, "Get Assault Assignment", GroundAssaultMenu, SelectNumPlayers , PlayerGroup )
    
  end
end

GroundAssault.SpawnT90 = SPAWN:New(GroundAssault.Settings.EnemyUnits.T90)
:InitHeading(0,359)
:InitRandomizePosition( true , 150, 15 )

GroundAssault.SpawnT80U = SPAWN:New(GroundAssault.Settings.EnemyUnits.T80U)
:InitHeading(0,359)
:InitRandomizePosition( true , 150, 15 )

GroundAssault.SpawnBTR80 = SPAWN:New(GroundAssault.Settings.EnemyUnits.BTR80)
:InitHeading(0,359)
:InitRandomizePosition( true , 150, 15 )

GroundAssault.SpawnMobileAAA = SPAWN:New(GroundAssault.Settings.EnemyUnits.MobileAAA)
:InitHeading(0,359)
:InitRandomizePosition( true , 150, 15 )

GroundAssault.SpawnSA13 = SPAWN:New(GroundAssault.Settings.EnemyUnits.SA13)
:InitHeading(0,359)
:InitRandomizePosition( true , 150, 15 )

GroundAssault.RusSoldier = SPAWN:New(GroundAssault.Settings.EnemyUnits.RusSoldier)
:InitHeading(0,359)
:InitRandomizePosition( true , 150, 15 )

GroundAssault.Transport1 = SPAWN:New(GroundAssault.Settings.EnemyUnits.Transport1)
:InitHeading(0,359)
:InitRandomizePosition( true , 150, 15 )

GroundAssault.Transport2 = SPAWN:New(GroundAssault.Settings.EnemyUnits.Transport2)
:InitHeading(0,359)
:InitRandomizePosition( true , 150, 15 )


