Extractions = Class:derive("Extractions")
Extractions.Settings = {}

Extractions.Settings.EnemyTroopSpawn = "Infantry Insurgent Solider EX"
Extractions.Settings.EnemyBTRSpawn = "Insurgent BTR-80 EX"
Extractions.Settings.EnemyTPzSpawn = "Insurgent Enemy TPz EX"
Extractions.EX_Zones = {
  "Extraction_001",
  "Extraction_002",
  "Extraction_003",
  "Extraction_004",
  "Extraction_005",
  "Extraction_006",
  "Extraction_007",
  "Extraction_008",
  "Extraction_009",
  "Extraction_010",
  "Extraction_011",
  "Extraction_012",
  "Extraction_013",
  "Extraction_014",
  "Extraction_015",
  "Extraction_016",
  "Extraction_017",
  "Extraction_018",
  "Extraction_019",
  "Extraction_020",
  "Extraction_021",
  "Extraction_022",
  "Extraction_023",
  "Extraction_024",
  "Extraction_025",
  "Extraction_026",
  "Extraction_027",
  "Extraction_028",
  "Extraction_029",
  "Extraction_030",
} --Extraction Zones

function Extractions:New(playerGroup)
  local PlayerGroup = playerGroup
  
  --check if already assigned a transport Assignment
  if TheFrat.GetMooseClientStateData(PlayerGroup,"hasAssignment") == true then
    TheFrat.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
    MESSAGE:New("You have already been assigned a Task. Please review your briefing from F10 Menu. Complete you current task before selecting a new one.",15):ToGroup(PlayerGroup)
  else
    if TheFrat.tablelength(Extractions.EX_Zones) >= 1 and TheFrat.tablelength(Settings.RadioFreqs) >= 1 then
      --lets set some vars
      local EnemyGroupSet = SET_GROUP:New()
      local RadioFreq = TheFrat.GetFreq()
      local inExtraction_Zone = false
      local troopsPickedUp = false
      local troopsUnloaded = false
      local ExtractionCompleted = false --Is CSAR mission Completed?
      local inAirSpace = false --within FARP Hollywood Airspace
      local firstTakeoff = false
      local Task_ID = TheFrat.RandomNumber()

      --moose client hasAssigment to true
      TheFrat.SetMooseClientStateData(PlayerGroup,"hasAssignment", true)
      
      --select random extraction zone
      local zoneName = TheFrat.randomchoice(Extractions.EX_Zones)
      local Zone = ZONE:New(zoneName)
      TheFrat.removeTableEntry(Extractions.EX_Zones,zoneName)
      local SpawnVec3Point = POINT_VEC3:NewFromVec3( Zone:GetVec3() )
      local LZ_AirSpace = ZONE_RADIUS:New( "Extract_LZ_"..TheFrat.RandomVariable(3), Zone:GetVec2(), 3704 )
      
     --Place Extraction Troops 
     local InfantryGroup = Extractions.AlliedSquadSpawn:SpawnFromVec2( Zone:GetVec2() )
     local numofTroops = InfantryGroup:CountInZone(Zone)
     local InfantryCargo = CARGO_GROUP:New( InfantryGroup, "Troop", "Troop"..TheFrat.RandomVariable(3), 500 )  
     
     --Spawn Random Enemy Units in route to LZ when not in allied zone
     local noEnemyThreatZones = Settings.NoThreatsZones --table
     table.insert(noEnemyThreatZones, LZ_AirSpace)

     
     --pop flare when near
     if Zone:GetCoordinate():IsDay() == true then
      --day do smoke
      
      local ExSmoke =SCHEDULER:New( nil,
        function()
          if PlayerGroup:IsCompletelyInZone(LZ_AirSpace) and inExtraction_Zone == false then
          inExtraction_Zone = true
          TheFrat.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
          PlayerGroup:Message("I hear you near by, popping red flare. Please hurry!",15)
            --pop Smoke
            Zone:SmokeZone(SMOKECOLOR.Red,1)
          end
        end, {}, 1,1,0,5400)
               
     else
     
      --night to flare
      local ExFlare = SCHEDULER:New( nil,
        function()
          if PlayerGroup:IsCompletelyInZone(LZ_AirSpace) and inExtraction_Zone == false then
          inExtraction_Zone = true
          TheFrat.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
          PlayerGroup:Message("I hear you near by, popping red flare. Please hurry!",15)
            --pop flare
          SCHEDULER:New( nil,
            function()
              Zone:FlareZone(FLARECOLOR.Red,1)
            end, {},2,4,0,180)
          end
        end, {}, 1,1,0,5400)
      
     end
      
      --spawn enemy forces
      local ranNumofTroops = math.random(4,8) --gen random number of troops math.random(3,5)
        for EnemyTroopCount = ranNumofTroops,1,-1
        do
          local group = Extractions.EnemyTroopSpawn:SpawnFromVec2( SpawnVec3Point:GetVec2() )  
          EnemyGroupSet:AddGroupsByName(group)
        end
        
     local ranNumofBTRs = math.random(0,2) --gen random number of troops math.random(3,5)
      for EnemyBTRCount = ranNumofBTRs,1,-1
      do
        local group = Extractions.EnemyBTRSpawn:SpawnFromVec2( SpawnVec3Point:GetVec2() )
        EnemyGroupSet:AddGroupsByName(group)
      end
    local ranNumofTPzs = math.random(0,1) --gen random number of troops math.random(3,5)
      for EnemyTPzCount = ranNumofTPzs,1,-1
      do
        local group = Extractions.EnemyTPzSpawn:SpawnFromVec2( SpawnVec3Point:GetVec2() )
        EnemyGroupSet:AddGroupsByName(group)
      end
      
      --Create Beacon
      local beaconID = TheFrat.CreateBeacon(Zone,RadioFreq)
      
      --Set Briefing Menu
     --Set Briefing Menu
      local ranSquad = TheFrat.randomchoice(Settings.Squads)
      local ranRank = TheFrat.randomchoice(Settings.Ranks)
      local ranName = TheFrat.randomchoice(Settings.Names)
      local Briefing = Extractions.GetBriefing(zoneName,ranSquad,ranRank,ranName)
      
      local brief = "Mission #: "..Task_ID.."\n"..
          "Pilot: "..PlayerGroup:GetPlayerName().."\n"..
          "Objective: Troop Extraction Operation\n"..
          "Number of Troops : "..numofTroops.."\n"..
          "______________________\n\n".. 
          "Mission : "..Briefing.."\n"..
          "______________________\n\n".. 
          "BRA: "..TheFrat.GetBearingToZone(PlayerGroup:GetVec3(),Zone:GetVec3())..'\n'..
          "ADF : "..RadioFreq.." Mhz FM\n"
           
      TheFrat.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
      MESSAGE:New(brief,35):ToGroup(PlayerGroup)
       
      local function showBriefing()
        TheFrat.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
        MESSAGE:New(brief,35):ToGroup(PlayerGroup)
      end
      local BriefingMenu = MENU_GROUP:New( PlayerGroup, "Your Assignment" )
      local BriefingMenuCommand = MENU_GROUP_COMMAND:New( PlayerGroup, "Briefing", BriefingMenu, showBriefing , PlayerGroup )
      
       --CREATE Task in DB
      local lz_lat, lz_long = coord.LOtoLL(Zone:GetPointVec3())
     
     
     --EVENTS
      --Takeoff
      PlayerGroup:HandleEvent(EVENTS.Takeoff)
      function PlayerGroup:OnEventTakeoff(EventData)
        
        if firstTakeoff == false then
          firstTakeoff = true
          --Leaving Safe Zone Check
          TheFrat.LeavingZoneCheck(PlayerGroup, Settings.SafeZone,"FARP Hollywood")
        end
      end--end EVENTS.Takeoff
    
      PlayerGroup:HandleEvent(EVENTS.Land)
      function PlayerGroup:OnEventLand(EventData)
        
        --check if picking up troops
        if PlayerGroup:IsCompletelyInZone(ZONE_RADIUS:New( "Extract_LZ_"..TheFrat.RandomVariable(3), Zone:GetVec2(), 121 )) and troopsPickedUp == false then 
           SCHEDULER:New( nil,
            function()
               --load troops
                --InfantryCargo:Board(PlayerGroup,25)
                InfantryCargo:Board(PlayerGroup,25) 
                troopsPickedUp = true
               
                TheFrat.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
                PlayerGroup:Message("= Troops now boarding =",5)
                ExFlare:Stop()
                TheFrat.StopBeacon(beaconID,RadioFreq) 
                
                -- Aftering pickign up troop Remove any Enemy Units if still alive after x minutes
                SCHEDULER:New( nil,
                function()
                  TheFrat.DestroyGroupSet(EnemyGroupSet)
                end, {},180)
                
                --check if in home airspace, if so flare
                SCHEDULER:New( nil,
                function()
                  if PlayerGroup:IsCompletelyInZone(ZONE:New("Hollywood Airspace")) and inAirSpace == false then
                    inAirSpace = true
                    TheFrat.FARPHollywoodSignal()
                  end
                end, {},300,15,0,3600)

            end, {}, 2)
        end
        
        --If Landing in Safe Zone and troop nounload then unload troopUnloaded=false
        if TheFrat.CheckIfInSafeZone(PlayerGroup,Settings.FARPHollywood_Allied_LZs) == true and troopsPickedUp == true and troopsUnloaded == false then
           SCHEDULER:New( nil,
            function()
               --load troops
               --MESSAGE:New("Unload...",3):ToAll()
               --InfantryCargo:UnBoard(POINT_VEC2:NewFromVec2(ZONE:New(TroopHoldZoneName):GetRandomVec2()))
               InfantryCargo:UnBoard()
               troopsUnloaded = true
               
               function InfantryCargo:onafterUnBoarding(ToPointVec2,Event,From,To,NearRadius)
                  --MESSAGE:New("On After Unboard Fire...",3):ToAll()
                  
                  BriefingMenu:Remove()
                  TheFrat.SetMooseClientStateData(PlayerGroup,"hasAssignment", false)
                  ExtractionCompleted = true
                  
                  --Task Successful
                  
                  local missionMarkerText = "Mission ID: "..Task_ID.." - Extraction\n"..
                                        "Pilot: "..PlayerGroup:GetPlayerName().."\n"..
                                        numofTroops.." troops extracted from battle."
                  TheFrat.CreateMarker(Zone,missionMarkerText,true)
                  
                  local MarkerText = "Mission ID: "..Task_ID.." - Extraction\\n"..
                                        "Pilot: "..PlayerGroup:GetPlayerName().."\\n"..
                                        numofTroops.." troops extracted from battle."
                  --TheFrat.AddMarkerTable(Zone,Task_ID,MarkerText,TheFrat.GetMooseClientStateData(PlayerGroup,"ucid"))
                                      
                  --Acknowledge
                  SCHEDULER:New( nil,
                    function()
                      TheFrat.PlaySoundTAll("radioscratch.ogg")
                      MESSAGE:New("Mission Successful! "..ranRank.." "..ranName.." and "..ranSquad.." has been extracted from battle! Nice Work "..PlayerGroup:GetPlayerName().."!",16,"HQ"):ToAll()

                    end, {},4)

               end
               
            end, {}, 2)
        end
        
      end
      
      PlayerGroup:HandleEvent(EVENTS.PlayerLeaveUnit)
      function PlayerGroup:OnEventPlayerLeaveUnit(EventData)
        if troopsUnloaded == false then
          BriefingMenu:Remove()
        end
        TheFrat.DestroyGroupSet(EnemyGroupSet)
        TheFrat.SetMooseClientStateData(PlayerGroup,"hasAssignment", false)

        if InfantryCargo:IsAlive() ~= nil and InfantryCargo:IsAlive() == true then
          InfantryCargo:Destroy()
        end
        TheFrat.StopBeacon(beaconID,RadioFreq)

      end
      
      PlayerGroup:HandleEvent(EVENTS.Dead)
      function PlayerGroup:OnEventDead(EventData)
        if troopsUnloaded == false then
          BriefingMenu:Remove()
        end
        --TheFrat.DestroyGroupSet(EnemyGroupSet)
        TheFrat.SetMooseClientStateData(PlayerGroup,"hasAssignment", false)

        if InfantryCargo:IsAlive() ~= nil and InfantryCargo:IsAlive() == true then
          InfantryCargo:Destroy()
        end
        TheFrat.StopBeacon(beaconID,RadioFreq)
        

      end
      
      --Crash
      PlayerGroup:HandleEvent(EVENTS.Crash)
      function PlayerGroup:OnEventCrash(EventData)
        if troopsUnloaded == false then
          BriefingMenu:Remove()
        end
        TheFrat.DestroyGroupSet(EnemyGroupSet)
        TheFrat.SetMooseClientStateData(PlayerGroup,"hasAssignment", false)

        if InfantryCargo:IsAlive() ~= nil and InfantryCargo:IsAlive() == true then
          InfantryCargo:Destroy()
        end
        TheFrat.StopBeacon(beaconID,RadioFreq)

      end
      
      

    else
      --no avalible zones or radio freqs
      TheFrat.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
      MESSAGE:New("Currently no Troop Extraction Assingments at this time, please try back later.",10):ToGroup(PlayerGroup)
    end--end if ln19
    
  end--end if ln15
  
end--end function


function Extractions:Menu(playerGroup)
  local PlayerGroup = playerGroup
  local PlayerGroupName = PlayerGroup:GetName()
  --Setup Menu Option
  local function ShowInst()
      local inst = "++ Troop Extraction Instructions ++"
      TheFrat.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
      MESSAGE:New(inst,10):ToGroup(PlayerGroup)
    end
  local function GetAssignment()
    TheFrat.PlaySoundToGroup("beep1.ogg",PlayerGroup)
    MESSAGE:New(">> Fetching Troop Extraction Assigment for "..PlayerGroupName,5):ToGroup(PlayerGroup)
    SCHEDULER:New( nil,
      function()
        TheFrat.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
        Extractions:New(PlayerGroup)
      end, {},6)
    
  end
  
  if TheFrat.ClientInTable(Settings.clientTransportsTable,PlayerGroupName) then
    local TroopInsertionMenu = MENU_GROUP:New( PlayerGroup, "Troop Transport" )
    --local TIInstrustions = MENU_GROUP_COMMAND:New( PlayerGroup, "Instructions", TroopInsertionMenu, ShowInst , PlayerGroup )--instr in CSAR class
    local GetTIAssignment = MENU_GROUP_COMMAND:New( PlayerGroup, "Get Troop Extraction Assignment", TroopInsertionMenu, GetAssignment , PlayerGroup )
  end

end

Extractions.AlliedSquadSpawn = SPAWN:New('Troop Extraction Templates')
      :InitRandomizeTemplate( {"Troop Extraction x 4","Troop Extraction x 5","Troop Extraction x 6","Troop Extraction x 8"} ) 
      :InitHeading(0,359)

Extractions.EnemyTroopSpawn = SPAWN:New(Extractions.Settings.EnemyTroopSpawn)
     --:InitRandomizeZones({Zone})
      --:InitLimit(4,4)
      :InitHeading(0,359)
      :InitRandomizePosition( true , 600, 500 )
      --:SpawnScheduled(0.5,0)

Extractions.EnemyBTRSpawn = SPAWN:New(Extractions.Settings.EnemyBTRSpawn)
      :InitHeading(0,359)
      :InitRandomizePosition( true , 1500, 1100 )

      
Extractions.EnemyTPzSpawn = SPAWN:New(Extractions.Settings.EnemyTPzSpawn)
      :InitHeading(0,359)
      :InitRandomizePosition( true , 1200, 1000 )
      
function Extractions.GetBriefing(ZoneName,ranSquad,ranRank,ranName)
  local briefing = ""
  
  briefing = ranRank.." "..ranName.." of " ..ranSquad.. " is requesting extraction. Get to there location at once and return them safely to FARP Hollywood."

  return briefing
end