AmbushZone = Class:derive("AmbushZone")--Do Not Remove!!!

--Settings
AmbushZone.EnemyUnitsLifeTime = 300 --(ex 600 = 10 min) in sec lifespan of ambush unit. this helps with performance by removing untis after a set amount of time as units will build up as you progress throught the mission
AmbushZone.MinNumTroops = 3 --Min #
AmbushZone.MaxNumTroops = 6 --Max #
AmbushZone.MinNumBTR = 0 --Min #
AmbushZone.MaxNumBTR = 1 --Max #
AmbushZone.MinNumTpz = 0 --Min #
AmbushZone.MaxNumTpz = 1 --Max #
AmbushZone.MinNumManPad = 0 --Min #
AmbushZone.MaxNumManPad = 0 --Max #
AmbushZone.ManPadTriggerHeight = 500 --trigger manpad only if pilot is at least this height in meters
AmbushZone.MinAmbushTime = 90 --Min time of possible ambush in sec ex. 180 = 3min
AmbushZone.MaxAmbushTime = 180 --Max time of possible ambush in sec ex. 300 = 5min
--End Settings

--Do not Edit Below this line unless you know what y ou are doing.
AmbushZone.InfantrySoliderInsurgentGroupName = "Infantry Insurgent Solider"
AmbushZone.EnemyBTRGroupName = "Insurgent BTR-80"
AmbushZone.EnemyTPzGroupName = "Insurgent Enemy TPz"
AmbushZone.EnemyManPadGroupName = "Infantry Insurgent Manpad"
function AmbushZone:New(PlayerUnit,safeZoneTable)--return InRoutScheduler()
  --GROUP:FindByName()
  local playerName = PlayerUnit:GetPlayerName()
  local InRoutScheduler = SCHEDULER:New( nil,
    function()
      if AmbushZone.CheckIfInSafeZone(PlayerUnit,safeZoneTable) == false  then
        
        --ZONE_RADIUS:New( "logistical_drop_airspace_"..TheFrat.RandomVariable(3), DropOffZone:GetVec2(), 3000 )
        --POINT_VEC3:NewFromVec3( _aheadPointInf )
        
        --doInsurgants
        local ranNumofTroops = math.random(AmbushZone.MinNumTroops,AmbushZone.MaxNumTroops) 
      
          for EnemyTroopCount = ranNumofTroops,1,-1
          do
           
            local _aheadPointInf = AmbushZone.getPointAheadOfUnit(PlayerUnit:GetName(), math.random(3200,3700),"Insurgant")
            --local group = InRouteEnemys.SpawnInsurgant:SpawnFromVec3( _aheadPointInf )
            local aheadPoint = POINT_VEC3:NewFromVec3( _aheadPointInf )
            local aheadZone = ZONE_RADIUS:New( "AmbushZone_"..TheFrat.RandomVariable(3), aheadPoint:GetVec2(), math.random(600,800) )
            local group = AmbushZone.SpawnInsurgant:SpawnInZone(aheadZone,true)
            SCHEDULER:New( nil,
            function()
              TheFrat.DestroyGroup(group)
            end, {},AmbushZone.EnemyUnitsLifeTime)          
  
          end
          
          if AmbushZone.MinNumBTR == 0 and AmbushZone.MaxNumBTR == 0 then
          --do nothing if zero
            else
              local ranNumofBTRS = math.random(AmbushZone.MinNumBTR,AmbushZone.MaxNumBTR) 
           
              for EnemyBTRCount = ranNumofBTRS,1,-1
              do
                local _aheadPointBTR = AmbushZone.getPointAheadOfUnit(PlayerUnit:GetName(), math.random(3200,3700),"BTR")
                local aheadPoint = POINT_VEC3:NewFromVec3( _aheadPointBTR )
                local aheadZone = ZONE_RADIUS:New( "AmbushZone_"..TheFrat.RandomVariable(3), aheadPoint:GetVec2(), math.random(600,800) )
                local group = AmbushZone.SpawnEnemyBTR:SpawnInZone(aheadZone,true)
                
                SCHEDULER:New( nil,
                function()
                  TheFrat.DestroyGroup(group)
                end, {},AmbushZone.EnemyUnitsLifeTime)
              end
            end

          if AmbushZone.MinNumTpz == 0 and AmbushZone.MaxNumTpz == 0 then
              --do nothing if zero
            else
              local ranNumofTPz = math.random(AmbushZone.MinNumTpz,AmbushZone.MaxNumTpz)
       
              for EnemyTpzCount = ranNumofTPz,1,-1
              do
                local _aheadPointTpz = AmbushZone.getPointAheadOfUnit(PlayerUnit:GetName(), math.random(3200,3700),"TPz")
                local aheadPoint = POINT_VEC3:NewFromVec3( _aheadPointTpz )
                local aheadZone = ZONE_RADIUS:New( "AmbushZone_"..TheFrat.RandomVariable(3), aheadPoint:GetVec2(), math.random(600,800) )
                local group = AmbushZone.SpawnEnemyTPz:SpawnInZone(aheadZone,true)
                
                SCHEDULER:New( nil,
                function()
                  TheFrat.DestroyGroup(group)
                end, {},AmbushZone.EnemyUnitsLifeTime)
              end
            end
          
         
          
          --possible man pad if over 1000 feet or 304 meters
          if AmbushZone.MinNumManPad == 0 and AmbushZone.MaxNumManPad == 0 then
            --do nothing if zero
          else
            if PlayerUnit:GetHeight() >= AmbushZone.ManPadTriggerHeight then
              local ranNumofMPs = math.random(AmbushZone.MinNumManPad,AmbushZone.MaxNumManPad) 
                for EnemyMPCount = ranNumofMPs,1,-1
                do
                  local _aheadPoint = AmbushZone.getPointAheadOfUnit(PlayerUnit:GetName(), math.random(3200,3700),"ManPad")
                  local aheadPoint = POINT_VEC3:NewFromVec3( _aheadPoint )
                  local aheadZone = ZONE_RADIUS:New( "AmbushZone_"..TheFrat.RandomVariable(3), aheadPoint:GetVec2(), math.random(600,800) )
                  local group = AmbushZone.SpawnEnemyManPad:SpawnInZone(aheadZone,true)
                  
                  SCHEDULER:New( nil,
                  function()
                    TheFrat.DestroyGroup(group)
                  end, {},AmbushZone.EnemyUnitsLifeTime)
                end
            end
          end
          
        
      end
    end, {},math.random(AmbushZone.MinAmbushTime,AmbushZone.MaxAmbushTime),math.random(AmbushZone.MinAmbushTime,AmbushZone.MaxAmbushTime),0.5,5400)
    
  
    PlayerUnit:HandleEvent(EVENTS.Dead)
    function PlayerUnit:OnEventDead(EventData)
      local unit = EventData.IniUnit
      if playerName == unit:GetPlayerName() then
        InRoutScheduler:Stop()
      end
    end
    
    PlayerUnit:HandleEvent(EVENTS.PlayerLeaveUnit)
    function PlayerUnit:OnEventPlayerLeaveUnit(EventData)
      local unit = EventData.IniUnit
      if playerName == unit:GetPlayerName() then
        InRoutScheduler:Stop()
      end
    end
    
end

AmbushZone.SpawnInsurgant = SPAWN:New(AmbushZone.InfantrySoliderInsurgentGroupName)
 :OnSpawnGroup(
  function( SpawnGroup )
    SpawnGroup:HandleEvent(EVENTS.Birth)
    function SpawnGroup:OnEventBirth(EventData)
     GROUP:FindByName(GroupName)
      
    end
    SpawnGroup:HandleEvent(EVENTS.Dead)
    function SpawnGroup:OnEventDead(EventData)
      
    end
  end
  )
  :InitHeading(0,359)
  
  
AmbushZone.SpawnEnemyBTR = SPAWN:New(AmbushZone.EnemyBTRGroupName)
 :OnSpawnGroup(
  function( SpawnGroup )
    SpawnGroup:HandleEvent(EVENTS.Birth)
    function SpawnGroup:OnEventBirth(EventData)
      
    end
    SpawnGroup:HandleEvent(EVENTS.Dead)
    function SpawnGroup:OnEventDead(EventData)
      
    end
  end
  )
  :InitHeading(0,359)
  
AmbushZone.SpawnEnemyTPz = SPAWN:New(AmbushZone.EnemyTPzGroupName)
 :OnSpawnGroup(
  function( SpawnGroup )
    SpawnGroup:HandleEvent(EVENTS.Birth)
    function SpawnGroup:OnEventBirth(EventData)

    end
    SpawnGroup:HandleEvent(EVENTS.Dead)
    function SpawnGroup:OnEventDead(EventData)
      
    end
  end
  )
  :InitHeading(0,359)

AmbushZone.SpawnEnemyManPad = SPAWN:New(AmbushZone.EnemyManPadGroupName)
 :OnSpawnGroup(
  function( SpawnGroup )
    SpawnGroup:HandleEvent(EVENTS.Birth)
    function SpawnGroup:OnEventBirth(EventData)

    end
    SpawnGroup:HandleEvent(EVENTS.Dead)
    function SpawnGroup:OnEventDead(EventData)
      
    end
  end
  )
  :InitHeading(0,359)
  
function AmbushZone.getPointAheadOfUnit(unitName, _offset,type)
    --type options Insurgant, BTR, TPz
    local getranPoint
    
      if type == "BTR" or type == "Manpad"then
        getranPoint = TheFrat.randomchoice({math.random(-1000,-1300),math.random(1000,1300)})
      else if type == "TPz" then
        getranPoint = TheFrat.randomchoice({math.random(-800,-1000),math.random(800,1000)})
      else 
        getranPoint = TheFrat.randomchoice({math.random(-200,-500),math.random(200,500)})
      end 
    end
    
    local _unit = Unit.getByName(unitName)
    local _position = _unit:getPosition()
    local _angle = math.atan2(_position.x.z, _position.x.x)
    local _xOffset = math.cos(_angle) * _offset
    local _yOffset = math.sin(_angle) * _offset

    local _point = _unit:getPoint()
    return { x = _point.x + _xOffset + getranPoint, z = _point.z + _yOffset, y = _point.y }
end
function AmbushZone.CheckIfInSafeZone(PlayerUnit,safeLandingZones)
  local result = false
  
  --check if in any save area zones on map
  for i = 1, #safeLandingZones do
    --print(i, ". ", safeLandingZones[i])
      if PlayerUnit:IsInZone(safeLandingZones[i]) then
        result = true
      end
  end

  return result
end