TheFrat = {}
--MissionEvent Container
MissionEvent = ""

--The Fraternity Welcome Message
function TheFrat.welcome_message(group,delay)
  local pilotName = group:GetPlayerName()
  local blank = ""
  
  if delay == nil then 
    delay = 8
  end
  
  MESSAGE:New("Connecting...", delay - 2):ToGroup(group)
  
  SCHEDULER:New( nil,
  function()
    --do time stuff
    local Tnow=timer.getAbsTime()
    local mission_time=Tnow-timer.getTime0()
    local mission_time_seconds=mission_time%60
    local mission_time_minutes=mission_time/60
    local local_time=UTILS.SecondsToClock(Tnow)
    local MissionTimeSec = Settings.FullMissionTime - mission_time
  
    --Discord Info
    --Time
    local dbLocalTime = TheFrat.SecondsToClock(Tnow)
    local dbMissionTimeLeft = TheFrat.SecondsToClock(MissionTimeSec)
  
    local WelcomeMsg = 
          "Welcome ".. pilotName .. ", To FARP Hollywood.\nBy Element.\n\n"..
          "===================\n"..
          "[ Current Time     : "..dbLocalTime.." ]\n"..
          "===================\n\n"..
          "View briefing for mission information and Use F10 to view your stats (if enabled).\n\n"..
          "For questions,comments,feedback visit our ED Forum Post.\n"..
          "Have Fun!!"
          
    TheFrat.PlaySoundToGroup("TheFraternityIntro.ogg",group)
    MESSAGE:New(WelcomeMsg, 20,"",true):ToGroup(group)
    
  end, {},delay)

end

function TheFrat.ClientInTable (tab, val)
  for index, value in ipairs(tab) do
    if value == val then
      return true
    end
  end

  return false
end

function TheFrat.CountGroupSet(groupSet)
local count = 0
groupSet:ForEachGroup(function(group)
        if group:IsAlive() then
          count = count + 1
        end
      end)
      return count
end

function TheFrat.CountUnitSet(unitSet)
local count = 0
unitSet:ForEachGroup(function(unit)
        if unit:IsAlive() then
          count = count + 1
        end
      end)
      return count
end

--play SoundFile to User Group
function TheFrat.PlaySoundToGroup(soundfile,group)
  local PlayAudioFile = USERSOUND:New( soundfile )
  PlayAudioFile:ToGroup(group)
end

--play SoundFile to All Users
function TheFrat.PlaySoundTAll(soundfile)
  local PlayToAll = USERSOUND:New( soundfile )
  PlayToAll:ToAll()
end

function TheFrat.PlaySoundToUnit(soundfile,unit)
  local PlayAudioFile = USERSOUND:New( soundfile )
  local group = unit:GetGroup()
  PlayAudioFile:ToGroup(group)
end

-- Select random item from table
function TheFrat.randomchoice(t) --Selects a random item from a table
  local keys = {}
  for key, value in pairs(t) do
    keys[#keys+1] = key --Store keys in another table
  end
  index = keys[math.random(1, #keys)]
  return t[index]
end
function TheFrat.sanitise( str )
    str = str:gsub('%W','')
    return str
end

function TheFrat.tablefind(tab,el)
    for index, value in pairs(tab) do
        if value == el then
            return index
        end
    end
end

function TheFrat.removeTableEntry(tabel,val)
  table.remove( tabel, TheFrat.tablefind(tabel, val) )
end

--Count number of items within table
function TheFrat.tablelength(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end

--Explode all units within a group
function TheFrat.explode(group)
  local unitsList = group:GetUnits()
    for i, unit in ipairs(unitsList) do
      TheFrat.explodeUnit(unit)
    end
end

function TheFrat.DestroyGroup(group)--will destroy all units in a group
  local unitsList = group:GetUnits()
    for i, unit in ipairs(unitsList) do
      if unit ~= nil and unit:IsAlive() == true then
        unit:Destroy()
      end
    end
end

function TheFrat.table_to_string(tbl)
    local result = ""
    for k, v in pairs(tbl) do
        -- Check the key type (ignore any numerical keys - assume its an array)
        if type(k) == "string" then
            result = result.."[\""..k.."\"]".."="
        end

        -- Check the value type
        if type(v) == "table" then
            result = result..table_to_string(v)
        elseif type(v) == "boolean" then
            result = result..tostring(v)
        else
            result = result..v.."\n"
        end
        result = result
    end
    -- Remove leading commas from the result
    if result ~= "" then
        result = result:sub(1, result:len()-1)
    end
    return result..""
end

function TheFrat.SecondsToClock(seconds)
  local seconds = tonumber(seconds)

  if seconds <= 0 then
    return "00:00:00";
  else
    hours = string.format("%02.f", math.floor(seconds/3600));
    mins = string.format("%02.f", math.floor(seconds/60 - (hours*60)));
    secs = string.format("%02.f", math.floor(seconds - hours*3600 - mins *60));
    return hours..":"..mins..":"..secs
  end
end

function TheFrat.DestroyGroupSet(groupSet)--Detroy (remove) every unit in group set
  groupSet:ForEachGroup(function(group)
  
  if group:IsAlive() ~= nil and group:IsAlive() == true then
    group:Destroy()
   end
  end)
end

--Explode all units in group set. Requires a SET Group
function TheFrat.explodeGroupSet(groupSet)
  groupSet:ForEachGroup(function(group)
    if group:IsAlive() ~= nil and group:IsAlive() == true then
      TheFrat.explode(group)
    end
  end)
  
end

--Explode Unit
function TheFrat.explodeUnit(unit)
  local boom1pos = unit:GetPointVec2()
  local pos = POINT_VEC2:New( boom1pos:GetLat(), boom1pos:GetLon() )
  trigger.action.explosion(pos, 100)
end

--Explode Static
function TheFrat.explodeStatic(static)
  local boom1pos = static:GetPointVec2()
  local pos = POINT_VEC2:New( boom1pos:GetLat(), boom1pos:GetLon() )
  trigger.action.explosion(pos, 100)
end

function TheFrat.SetMooseClientStateData(PlayerGroup,SetData, Data)
  local unitName = TheFrat.GetUnitFromPlayer(PlayerGroup:GetPlayerUnits())
  local Client = SET_CLIENT:New():AddClientsByName(unitName)
    Client:ForEachClient(
      function(MooseClient)
        MooseClient:SetState( MooseClient, SetData, Data )
      end
    )
  Client = nil
end

function TheFrat.GetMooseClientStateData(PlayerGroup,StateData)
  local data = ""
  local unitName = TheFrat.GetUnitFromPlayer(PlayerGroup:GetPlayerUnits())
  local Client = SET_CLIENT:New():AddClientsByName(unitName)
    Client:ForEachClient(
      function(MooseClient)
        --MESSAGE:New('Your UCID '..MooseClient:GetState( MooseClient, "UCID" ),10):ToClient(MooseClient)
        data = MooseClient:GetState( MooseClient, StateData )
      end
    )
  Client = nil
  return data
end
function TheFrat.GetUnitFromPlayer(GetPlayerUnitsTable)
  local unitsTables = GetPlayerUnitsTable
  for UnitId, UnitData in pairs( unitsTables ) do
      local UnitAction = UnitData -- Wrapper.Unit#UNIT
      return UnitAction:Name()
    end
end
function TheFrat.RandomVariable(length)
  local res = ""
  for i = 1, length do
    res = res .. string.char(math.random(97, 122))
  end
  return res
end

function TheFrat.RandomNumber()
  return math.random(10000000, 65000000)
end

function TheFrat.FARPHollywoodBeacon(zone,radiofreq,beaconID)--return beacon id
  local Frequency = radiofreq * 1000000 -- Conversion to Hz
  local audio = "l10n/DEFAULT/".."beacon.ogg"

  SCHEDULER:New( nil,
    function()
      --trigger.action.radioTransmission(audio, zone:GetVec3(), 1, false,Frequency, 1000,beaconID)
      TheFrat.CreateBeacon(zone,radiofreq,beaconID)
    end, {}, 5)
  
end

function TheFrat.FARPHollywoodSignal()--flare FARP every x min default every 1 hr (3600 in secs)

  --flare zone
  ZONE:New("FARPHollywood_Hold"):FlareZone(FLARECOLOR.Yellow,2)
  SCHEDULER:New( nil,
    function()
      ZONE:New("FARPHollywood_Hold"):FlareZone(FLARECOLOR.Green,1)
    end, {}, 3,3,0,9)
end

function TheFrat.GetBearingToObj(from,to) 
  local group_1_pos = Group.getByName(from):getUnits()[1]:getPoint()
  local group_2_pos = Group.getByName(to):getUnits()[1]:getPoint()
  local distance = ((group_1_pos.x - group_2_pos.x)^2 + (group_1_pos.z - group_2_pos.z)^2)^0.5
  local bearing_vector = {
    x = group_2_pos.x - group_1_pos.x, 
    y = group_2_pos.y - group_1_pos.y, 
    z = group_2_pos.z - group_1_pos.z
    }
  local bearing_rad = math.atan2(bearing_vector.z, bearing_vector.x)
  if bearing_rad < 0 then
      bearing_rad = bearing_rad + (2 * math.pi) 
    end
    local bearing = math.deg(bearing_rad)
    return 'Go Bearing '..math.floor(bearing)..' Degrees for about '..math.floor(UTILS.MetersToNM(distance)).." Nm."
end
function TheFrat.GetBearingToZone(groupPoint,zonePoint) 
  local group_1_pos = groupPoint
  local group_2_pos = zonePoint
  local distance = ((group_1_pos.x - group_2_pos.x)^2 + (group_1_pos.z - group_2_pos.z)^2)^0.5
  local bearing_vector = {
    x = group_2_pos.x - group_1_pos.x, 
    y = group_2_pos.y - group_1_pos.y, 
    z = group_2_pos.z - group_1_pos.z
    }
  local bearing_rad = math.atan2(bearing_vector.z, bearing_vector.x)
  if bearing_rad < 0 then
      bearing_rad = bearing_rad + (2 * math.pi) 
    end
    local bearing = math.deg(bearing_rad)
    return math.floor(bearing)..' Degrees for about '..math.floor(UTILS.MetersToNM(distance)).." Nm."
end

function TheFrat.CheckIfInSafeZone(PlayerGroup,safeLandingZones)
  local result = false
  for i = 1, #safeLandingZones do
    --print(i, ". ", safeLandingZones[i])
      if PlayerGroup:IsCompletelyInZone(safeLandingZones[i]) then
        result = true
      end
  end
  return result
end


function TheFrat.GetBRAInfoToZone(groupPoint,zonePoint)
  local data = {} 
  local group_1_pos = groupPoint
  local group_2_pos = zonePoint
  local distance = ((group_1_pos.x - group_2_pos.x)^2 + (group_1_pos.z - group_2_pos.z)^2)^0.5
  local bearing_vector = {
    x = group_2_pos.x - group_1_pos.x, 
    y = group_2_pos.y - group_1_pos.y, 
    z = group_2_pos.z - group_1_pos.z
    }
  local bearing_rad = math.atan2(bearing_vector.z, bearing_vector.x)
  if bearing_rad < 0 then
      bearing_rad = bearing_rad + (2 * math.pi) 
    end
    local bearing = math.deg(bearing_rad)
    --return math.floor(bearing)..' Degrees for about '..math.floor(UTILS.MetersToNM(distance)).." Nm."
    data.bearing = math.floor(bearing) -- in Degrees
    data.distance = math.floor(UTILS.MetersToNM(distance)) -- in Nm
    return data
end

function TheFrat.LeavingZoneCheck(group, zone, messageCat)
  
  if messageCat == nil then
    messageCat = "HQ"
  end
  
  local _leftzone = false
  
  local timers = SCHEDULER:New( nil,
    function()
    if group:IsCompletelyInZone(zone) == false and _leftzone == false then
      _leftzone = true
      TheFrat.PlaySoundToGroup("radioscratch.ogg",group)
      MESSAGE:New(group:GetPlayerName()..", You are now leaving allied airspace and entering enemy territory. Proceed with extreme caution. Flying too high in enemy territory could be fatal.",20, messageCat):ToGroup(group)
    end
      
    end, {},5,5,0.7,3600)
end

function TheFrat.getPointAheadOfUnit(_unit, _offset)
    
    local getranPoint = math.random(-1500,1500)
    local _position = _unit:getPosition()
    local _angle = math.atan2(_position.x.z, _position.x.x)
    local _xOffset = math.cos(_angle) * _offset
    local _yOffset = math.sin(_angle) * _offset

    local _point = _unit:getPoint()
    return { x = _point.x + _xOffset + getranPoint, z = _point.z + _yOffset, y = _point.y }
end

function TheFrat.readAll(file)
    local f = assert(io.open(file, "rb"))
    local content = f:read("*all")
    f:close()
    return content
end

function TheFrat.CreateMarker(unit,text,readOnly,expire)
  local coord = unit:GetCoordinate()
  if readOnly == nil then
    readOnly = false
  end
    
  if expire == nil or expire == 0 then
    --never expire
    coord:MarkToAll(text,readOnly)
  else
    --add with timer
    local markID = coord:MarkToAll(text,readOnly)
    local markerScheduler = SCHEDULER:New( nil,
          function()
            coord:RemoveMark(markID)
          end, {},expire)
  end
    
end

function TheFrat.LeavingSafeZoneCheck(Unit)
  local warning = false
  local group = Unit:GetGroup()
  local checkSch = SCHEDULER:New( nil,
  function()
    if AmbushZone.CheckIfInSafeZone(Unit,Settings.NoThreatsZones) == false and warning == false then
       warning = true
       TheFrat.PlaySoundToUnit("radioscratch.ogg",Unit)
       MESSAGE:New(Unit:GetPlayerName()..", be advised you are now entering enemy territory.",15,"HQ"):ToGroup(group)
    end
  end, {}, 1,1,0,3600)

end

function TheFrat.AddMarkerTable(unit,missionID,text,ucid)
  --Settings.CurrentMissionMarkers
  local data = {}
  local PointVec3 = unit:GetPointVec3()
  local user_id = string.sub(ucid,1,8)
  local ID = missionID
  local markerText = text
  local lat, long = coord.LOtoLL(PointVec3)
  local LLString = UTILS.tostringLL( lat, long, 2, false )
  
  --add data
  data.id = ID
  data.ucid = user_id
  data.lat = lat
  data.long = long
  data.LLString = LLString
  data.markerText = markerText
  
  table.insert(Settings.CurrentMissionMarkers, data)
  
  --testing
  --TheFrat.AddMarkerTable(unit,markID,text,TheFrat.GetMooseClientStateData(PlayerGroup,"ucid"))
  
end

function TheFrat.MakersJson(time)

 if time == nil then time = 30
  end

  SCHEDULER:New( nil,
    function()
    
      local CompletedMarkersJsonFile = Settings.CompletedMarkersJsonFile
      local file2 = io.open(CompletedMarkersJsonFile, "w+")
      file2:write("[") --start of new marker item
    
        for i, data in ipairs(Settings.CurrentMissionMarkers) do
          --MESSAGE:New(tostring(data.id),3):ToAll()
          local id = tostring(data.id)
          local user_id = tostring(data.user_id)
          local lat = tostring(data.lat)
          local long = tostring(data.long)
          local LLString = tostring(data.LLString)
          local markerText = tostring(data.markerText)
          
          file2:write("{") --start of new marker item
          file2:write('"id":' ..'"'..id..'"'..",")
          file2:write('"user_id":' ..'"'..user_id..'"'..",")
          file2:write('"lat":' ..'"'..lat..'"'..",")
          file2:write('"long":' ..'"'..long..'"'..",")
          file2:write('"LLString":' ..'"'..LLString..'"'..",")
          file2:write('"markerText":' ..'"'..markerText..'"')
          file2:write("},") --end of new marker item
        end
      
      file2:close()

      --now lets remove the trailing comma for valid json
      --let us read the file.
      local f = assert(io.open(CompletedMarkersJsonFile, "rb"))
      local content = f:read("*all")
      f:close()
      
      --remove last comma
      if TheFrat.tablelength(Settings.CurrentMissionMarkers) >= 1 then
        content = content:sub(1, -2)
      end
      
      --add contents and tailing json to complet json
      local f2 = assert(io.open(CompletedMarkersJsonFile, "w+"))
      f2:write(content)
      f2:write("]")
      f2:close()
      
    end, {},time,time)
end

function TheFrat.CreateBeacon(zone,radiofreq,ID)--return beacon id
  local beaconID
  if ID == nil then
     beaconID = zone:GetName().."_"..TheFrat.RandomVariable(4)
  else
    beaconID = ID
  end
  local radioFreq = radiofreq
  local _newBeacon = {
      beaconID = beaconID,
      zone = zone,
      radioFreq = radioFreq,
    }
    
  --add beacon to tbl
  table.insert(Settings.Beacons, _newBeacon)
  BASE:E( "Beacon Created - ID: "..beaconID..", Freq: "..radiofreq.." Mhz, Zone: "..zone:GetName())
  
  --Update
  TheFrat.RefreshBeacons()
  
  return beaconID
end

function TheFrat.RefreshBeacons()--table of beacons
  local audio = "l10n/DEFAULT/".."beacon.ogg"
  --will reboardcast all beacons
  for _, beacon in pairs(Settings.Beacons) do
    local Frequency = beacon.radioFreq * 1000000 -- Conversion to Hz
    --MESSAGE:New("BroadCasting : [ ID - " .. beacon.beaconID .. " Freq - "..beacon.radioFreq .. " ZoneName - "..beacon.zone:GetName().." ]",5):ToAll()
    --trigger.action.stopRadioTransmission(beacon.beaconID)
    trigger.action.radioTransmission(audio, beacon.zone:GetVec3(), radio.modulation.FM, false,Frequency, 1000,beacon.beaconID)
  end

end

function TheFrat.StopBeacon(beaconId,Freq)
  --remove beacon from table
  TheFrat.removeTableEntry(Settings.Beacons,beaconId)
  table.insert (Settings.RadioFreqs, Freq)
  --stop beacon
  trigger.action.stopRadioTransmission(beaconId)
  BASE:E( "Beacon Stopped - ID: "..beaconId..", Freq: "..Freq.." Mhz")
  TheFrat.RefreshBeacons()
end

function TheFrat.GetFreq()
  local randomFreq = TheFrat.randomchoice(Settings.RadioFreqs)
  TheFrat.removeTableEntry(Settings.RadioFreqs,randomFreq)
  return randomFreq
end

function TheFrat.BeaconScheduler()
    --MESSAGE:New("BeaconScheduler",5):ToAll()
    timer.scheduleFunction(TheFrat.BeaconScheduler, nil, timer.getTime() + 5)
    TheFrat.RefreshBeacons()
end

function TheFrat.KobuletiC17()
  SCHEDULER:New( nil,
  function()
    local C17 = SPAWN:New( "Kobuleti C-17A" )
      :OnSpawnGroup(
        function( SpawnGroup )
          SpawnGroup:HandleEvent(EVENTS.Birth)
          function SpawnGroup:OnEventBirth(EventData)
            
          end
          SpawnGroup:HandleEvent(EVENTS.Land)
          function SpawnGroup:OnEventLand(EventData)
            SCHEDULER:New( nil,
            function()
              SpawnGroup:Respawn()
            end, {},240)
            
            
          end
        end
        )
    C17:Spawn()
  end, {},math.random(3,6))
  
end

--GMapsAllActivePlanes()
function TheFrat.GMapsAllActiveUnits()
  --UTILS.tostringLL( lat, long, _SETTINGS.LL_Accuracy, true ).." | MRGS: "..UTILS.tostringMGRS( coord.LLtoMGRS( lat, long ), _SETTINGS.MGRS_Accuracy )
  --locaton of JsonFile
  local GMapsUnitSetJsonfile = Settings.GMapsFile
  local userName = ""

  --creat json file
  local file2 = io.open(GMapsUnitSetJsonfile, "w+")
  file2:write('eqfeed_callback({"markers": [') --top of json file
  --air planes
  Settings.AllUnitsSet:ForEachUnit(
    function(Unit)
      if Unit:IsAlive() ==  true then
        local lat, long = coord.LOtoLL(Unit:GetPointVec3())
        local name = Unit:GetName()
        if Unit:GetPlayerName() ~= nil then userName = Unit:GetPlayerName() end
        if userName ~= "" then userName = userName:gsub('%W','') end
        file2:write("{") --start of new marker item
        file2:write('"name":' ..'"'..name..'"'..",")
        if Unit:GetPlayerName() ~= nil then file2:write('"playername":' ..'"'..userName..'"'..",") else file2:write('"playername":' ..'"'..'"'..",") end
        file2:write('"coordinates":' .."[".. lat..","..long.."]"..",")
        file2:write('"categoryname":' ..'"'..Unit:GetCategoryName()..'"'..",")
        file2:write('"fuel":' ..'"'..Unit:GetFuel()..'"'..",")
        file2:write('"life":' ..'"'..Unit:GetLife()..'"'..",")
        file2:write('"threatlevel":' ..'"'..Unit:GetThreatLevel()..'"'..",")
        file2:write('"heading":' ..'"'..Unit:GetHeading()..'"'..",")
        if Unit:GetVelocityKMH() ~= nil then file2:write('"speedkmh":' ..'"'..Unit:GetVelocityKMH()..'"'..",") else file2:write('"speedkmh":' ..'"'..'"'..",") end
        file2:write('"altitude":' ..'"'..Unit:GetAltitude()..'"'..",")
        file2:write('"coalition":' ..'"'..Unit:GetCoalition()..'"'..",")
        file2:write('"coalitionname":' ..'"'..Unit:GetCoalitionName()..'"'..",")
        file2:write('"LL":' ..'"'..UTILS.tostringLL( lat, long, 2, false )..'"'..",")
        file2:write('"MGRS":' ..'"'..UTILS.tostringMGRS( coord.LLtoMGRS( lat, long ), 4 )..'"'..",")
        file2:write('"typename":' ..'"'..Unit:GetTypeName()..'"')
        file2:write("},") --end of new marker item
      end
      userName = "" --reset username
    end
  )--end forEachUnit
  file2:close()
  
  --now lets remove the trailing comma for valid json
  --let us read the file.
  local f = assert(io.open(GMapsUnitSetJsonfile, "rb"))
  local content = f:read("*all")
  f:close()
  
  --remove last comma
  content = content:sub(1, -2)
  
  --add contents and tailing json to complet json
  local f2 = assert(io.open(GMapsUnitSetJsonfile, "w+"))
  f2:write(content)
  f2:write('],"timestamp":"'..timer.getTime()..'"});') --end of Json file
  f2:close()
end

function TheFrat.OnlinePlayersJSON()
  --write data to JSON
  local count = 0
  local OnlineUsersFile = Settings.OnlineUsersFile
  local file2 = io.open(OnlineUsersFile, "w+")
  file2:write('[') --start of new marker item

  Settings.AllUnitsSet:ForEachUnit(
      function(Unit)
        if Unit:IsAlive() == true and Unit:GetPlayerName() ~= nil then
          --local name = Unit:GetName()
          count = count + 1
          local playerName = Unit:GetPlayerName()
          local uid = TheFrat.GetMooseClientStateData(Unit:GetGroup(),'ucid')
          --local module = Unit:GetTypeName()

          file2:write('{"uid":' ..'"'..uid..'"'..","..'"name":' ..'"'..playerName..'"'.."},")

        end

      end
    )--end forEachUnit
    if count == 0 then
      file2:write("]")
      file2:close()
    else
      file2:close()
      --now lets remove the trailing comma for valid json
      --let us read the file.
      local f = assert(io.open(OnlineUsersFile, "rb"))
      local content = f:read("*all")
      f:close()

      --remove last comma
      content = content:sub(1, -2)
      
      --add tailing ]
      local f2 = assert(io.open(OnlineUsersFile, "w+"))
      f2:write(content)
      f2:write("]")
      f2:close()
        end
        
      --END of script
end

--Get each line of a file
function TheFrat.magiclines(s)
        if s:sub(-1)~="\n" then s=s.."\n" end
        return s:gmatch("(.-)\n")
end

function TheFrat.GetLine(source,num)
  local linecount = 0
  for line in TheFrat.magiclines(source) do 
        linecount = linecount + 1  
        if linecount == num then
            return line
        end
      end 
end

function TheFrat.ResetWarnings()
    warning1 = SCHEDULER:New( nil,
      function()
        --TheFrat.PlaySoundTAll("radioscratch.ogg")
        MESSAGE:New("++ Server will Restart in about 2 Hours ++",15):ToAll()
        --TheFrat.LogEvent("MissionUpdate","Server will Restart in about 2 Hours")
      end, {}, 21600)
  
    warning2 = SCHEDULER:New( nil,
      function()
        --TheFrat.PlaySoundTAll("radioscratch.ogg")
        MESSAGE:New("++ Server will Restart in about 1 Hour ++",15):ToAll()
        --TheFrat.LogEvent("MissionUpdate","Server will Restart in about 1 Hour")
      end, {}, 25200)
  
    warning3 = SCHEDULER:New( nil,
      function()
        --TheFrat.PlaySoundTAll("radioscratch.ogg")
        MESSAGE:New("++ Server will Restart in about 30 min ++",15):ToAll()
        --TheFrat.LogEvent("MissionUpdate","Server will Restart in about 30 minutes.")
      end, {}, 27000)
  
    warning4 = SCHEDULER:New( nil,
      function()
        --TheFrat.PlaySoundTAll("radioscratch.ogg")
        MESSAGE:New("++ Server will Restart in about 15 min ++",15):ToAll()
        --TheFrat.LogEvent("MissionUpdate","Server will Restart in about 15 minutes.")
      end, {}, 27900)
  
    warning5 = SCHEDULER:New( nil,
      function()
        TheFrat.PlaySoundTAll("radioscratch.ogg")
        MESSAGE:New("++ Server will Restart in about 5 min ++",15):ToAll()
      end, {}, 28500)
end


timer.scheduleFunction(TheFrat.BeaconScheduler, nil, timer.getTime() + 5)
TheFrat.KobuletiC17()--Kobuleti C-17A repeat landing