TroopInsertion = Class:derive("TroopInsertion")
TroopInsertion.Settings = {
  EnemySoliderSpawnGroupName = "Infantry Solider Rus FHW",
  EnemyBTRGroupName = "Insurgent Enemy BTR-80 FHW",
  farewells = {
      "Have a safe flight.",
      "God Speed.",
      "Have a safe flight sir.",
      "Good luck.",
      "Good luck sir, have a safe flight.",
    }
}
TroopInsertion.TI_Zones = { --Name of Zones to offere Troop Insertion
  "TI_Zone_001",
  "TI_Zone_002",
  "TI_Zone_003",
  "TI_Zone_004",
  "TI_Zone_005",
  "TI_Zone_006",
  "TI_Zone_007",
  "TI_Zone_008",
  "TI_Zone_009",
  "TI_Zone_010",
  "TI_Zone_011",
  "TI_Zone_012",
  "TI_Zone_013",
  "TI_Zone_014",
  "TI_Zone_015",
  "TI_Zone_016",
  "TI_Zone_017",
  "TI_Zone_018",
  "TI_Zone_019",
  "TI_Zone_020",
  "TI_Zone_021",
  "TI_Zone_022",
  "TI_Zone_023",
  "TI_Zone_024",
  "TI_Zone_025",
  "TI_Zone_026",
  "TI_Zone_027",
  "TI_Zone_028",
  "TI_Zone_029",
  "TI_Zone_030",
  "TI_Zone_031",
  "TI_Zone_032",
  "TI_Zone_033",
  "TI_Zone_034",
  "TI_Zone_035",

}


function TroopInsertion:New(playerGroup)
  local PlayerGroup = playerGroup
  local PlayerGroupName = PlayerGroup:GetName()
  
  if TheFrat.GetMooseClientStateData(PlayerGroup,"hasAssignment") == true then
    TheFrat.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
    MESSAGE:New("You have already been assigned a Task. Please review your briefing from F10 Menu. Complete you current task before selecting a new one.",15):ToGroup(PlayerGroup)
  else
    
    if TheFrat.tablelength(TroopInsertion.TI_Zones) >= 1 and TheFrat.tablelength(Settings.RadioFreqs) >= 1 then
      
      --set some local vars
      local EnemyGroupSet = SET_GROUP:New()
      local troopsUnloaded = false
      local missionCompleted = false
      local firstTakeoff = false
      local inHomeAirSpace = false
      local inLZ_Zone = false
      local numofTroops = math.random(4,8) --number of troops to carry in allied helo
      local zoneName = TheFrat.randomchoice(TroopInsertion.TI_Zones)
      local wpzoneName = zoneName.."_wp"
      local Zone = ZONE:New(zoneName)
      local WPZone = ZONE:New(wpzoneName)
      local ZoneVec3 = POINT_VEC3:NewFromVec3( Zone:GetVec3() )
      local RadioFreq = TheFrat.GetFreq()
      local flareZone = ZONE_RADIUS:New( "FlareZone", Zone:GetVec2(), 2600 )
      local landingZone = ZONE_RADIUS:New( "LZ", Zone:GetVec2(), 245 )
      local braInfo = TheFrat.GetBRAInfoToZone(PlayerGroup:GetVec3(),Zone:GetVec3()) -- data.bearing, data.distance
      TheFrat.removeTableEntry(TroopInsertion.TI_Zones,zoneName)
      local Task_ID = TheFrat.RandomNumber()
      
      --Set has state to true
      TheFrat.SetMooseClientStateData(PlayerGroup,"hasAssignment", true)
       
      --Set Briefing Menu
      local ranSquad = TheFrat.randomchoice(Settings.Squads)
      local ranRank = TheFrat.randomchoice(Settings.Ranks)
      local ranName = TheFrat.randomchoice(Settings.Names)
      local Briefing = TroopInsertion.GetBriefing(zoneName,ranSquad,ranRank,ranName)
      
      local brief = "Mission #: "..Task_ID.."\n"..
          "Pilot: "..PlayerGroup:GetPlayerName().."\n"..
          "Objective: Troop Insertion/Transport Operation\n"..
          "Number of Troops : "..numofTroops.."\n"..
          "______________________\n\n".. 
          "Mission : "..Briefing.."\n"..
          "______________________\n\n".. 
          "BRA: "..TheFrat.GetBearingToZone(PlayerGroup:GetVec3(),Zone:GetVec3())..'\n'..
          "ADF : "..RadioFreq.." Mhz FM\n"
           
      TheFrat.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
      MESSAGE:New(brief,35):ToGroup(PlayerGroup)
      
      --CREATE Task in DB
      local lz_lat, lz_long = coord.LOtoLL(Zone:GetPointVec3())

      local function showBriefing()
        TheFrat.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
        MESSAGE:New(brief,35):ToGroup(PlayerGroup)
      end
      local BriefingMenu = MENU_GROUP:New( PlayerGroup, "Your Assignment" )
      local BriefingMenuCommand = MENU_GROUP_COMMAND:New( PlayerGroup, "Briefing", BriefingMenu, showBriefing , PlayerGroup )
      
      --Spawn Random Enemy Units in route to LZ when not in allied zone
      local noEnemyThreatZones = Settings.NoThreatsZones --table
      table.insert(noEnemyThreatZones, Zone)
                  
      --Create Beacon
      local beaconID = TheFrat.CreateBeacon(Zone,RadioFreq)
      
      --do enemy units
      local ranNumofOutSideTroops = math.random(5,10) --gen random number of troops math.random(3,5)
        for EnemyTroopCounts = ranNumofOutSideTroops,1,-1
        do
          local grp = TroopInsertion.EnemyTroopSpawnRandomizePosition:SpawnFromVec2( Zone:GetVec2() )  
          EnemyGroupSet:AddGroupsByName(grp)
        end
        
      local ranNumofBTRs = math.random(2,3) --gen random number of troops math.random(3,5)
        for EnemyBTRCount = ranNumofBTRs,1,-1
        do
          local btrgrp = TroopInsertion.EnemyBTRSpawn:SpawnFromVec2( Zone:GetVec2() )
          EnemyGroupSet:AddGroupsByName(btrgrp)
        end

      --Load Troops onto Transport Unit after x sec
      SCHEDULER:New( nil,
      function()
        TheFrat.PlaySoundToGroup("chirp.ogg",PlayerGroup)
        ctld.preLoadTransport(PlayerGroupName, 6,true)
      end, {},15)
      
      if Zone:GetCoordinate():IsDay() == true then
        --day smoke
        local popSmoke = SCHEDULER:New( nil,
          function()
            if PlayerGroup:IsCompletelyInZone(flareZone) and inLZ_Zone == false then
            inLZ_Zone = true
            TheFrat.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
            PlayerGroup:Message("We hear you near by, popping blue smoke!",15)
              --pop smoke
              Zone:SmokeZone(SMOKECOLOR.Blue,1)
            end
          end, {}, 2,2,0.5,5400)
      else
        --nigh flare
        local popFlare = SCHEDULER:New( nil,
          function()
            if PlayerGroup:IsCompletelyInZone(flareZone) and inLZ_Zone == false then
            inLZ_Zone = true
            TheFrat.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
            PlayerGroup:Message("We hear you near by, popping yellow flares!",15)
              --pop flare
            SCHEDULER:New( nil,
              function()
                Zone:FlareZone(FLARECOLOR.Yellow,1)
              end, {},2,4,0,180)
            end
          end, {}, 2,2,0.5,5400)
      end
      
       
      
      
      --EVENTS
      --Takeoff
      PlayerGroup:HandleEvent(EVENTS.Takeoff)
      function PlayerGroup:OnEventTakeoff(EventData)
     
      
        --first takeoff
        if firstTakeoff == false then
          firstTakeoff = true
          SCHEDULER:New( nil,
            function()
              TheFrat.PlaySoundToGroup("chirp.ogg",PlayerGroup)
              MESSAGE:New(PlayerGroup:GetPlayerName().." go bearing "..braInfo.bearing.." Degrees. "..TheFrat.randomchoice(TroopInsertion.Settings.farewells),15, "Hollywood ATC"):ToGroup(PlayerGroup)
            end, {},math.random(20,40))
            
            
          --Leaving Safe Zone Check
          TheFrat.LeavingZoneCheck(PlayerGroup, Settings.SafeZone,"FARP Hollywood")
            
        end

        
      end--end EVENTS.Takeoff
      
      --Landing
      PlayerGroup:HandleEvent(EVENTS.Land)
        function PlayerGroup:OnEventLand(EventData)
          --check if landing in zone to drop off troops
          if PlayerGroup:IsCompletelyInZone(landingZone) and troopsUnloaded == false then 
             SCHEDULER:New( nil,
              function()
                  --unload troops
                 troopsUnloaded = true
                 local grpname = ctld.unloadTransport(PlayerGroupName)
                 SCHEDULER:New( nil,
                    function()
                      TheFrat.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
                      MESSAGE:New("Troops are out! Go! Go! Go!",5, "Crew Chief"):ToGroup(PlayerGroup)
                    end, {},5)

                 local grp = GROUP:FindByName(grpname)
                 
                 TheFrat.StopBeacon(beaconID,RadioFreq)
                 --popFlare:Stop()
                 SCHEDULER:New( nil,
                    function()
                      --MESSAGE:New("Troop moving to WP Zone",3):ToAll()
                      local controller = grp:_GetController()
                      controller:setOption(AI.Option.Ground.id.ROE,0)
                      local controller_task = {
                                id = 'ComboTask',
                                params = {
                                  tasks = grp:TaskRouteToVec2(WPZone:GetVec2())
                                  }
                                }
                      controller:setTask(controller_task)
                      
                      SCHEDULER:New( nil,
                          function()
                            --SpawnEnemyTroopsAtWP(math.random(4,6))
                            --TroopInsertion.SpawnEnemyTroopsAtWP(numofTroops)
                            local ranNumofTroops = numofTroops --gen random number of troops math.random(3,5)
                              for EnemyTroopCount = ranNumofTroops,1,-1
                              do
                                local group = TroopInsertion.EnemyTroopSpawn:SpawnInZone(WPZone,true)
                                EnemyGroupSet:AddGroupsByName(group)
                              end
                          end, {},3)
                        
                        --remove units after 10 min
                        SCHEDULER:New( nil,
                          function()
                            --MESSAGE:New("Destroy Group",5):ToAll()
                            TheFrat.DestroyGroupSet(EnemyGroupSet)
                            TheFrat.DestroyGroup(grp)
                          end, {},600)
                          
                         --check if in home airspace, if so flare
                          SCHEDULER:New( nil,
                          function()
                            if PlayerGroup:IsCompletelyInZone(ZONE:New("Hollywood Airspace")) and inHomeAirSpace == false then
                              inHomeAirSpace = true
                              TheFrat.FARPHollywoodSignal()
                            end
                          end, {},120,15,0.4,3600)
                        
                      
                    end, {},5)
                 
                 
                 
              end, {}, 3)
          end --end if
          
          --If Landing in allied Zone and troop are unloaded 
          if TheFrat.CheckIfInSafeZone(PlayerGroup,Settings.FARPHollywood_Allied_LZs) and troopsUnloaded == true and missionCompleted == false then 
            missionCompleted = true
            --Task Successful

            SCHEDULER:New( nil,
              function()
                TheFrat.PlaySoundTAll("info.ogg")
                MESSAGE:New(PlayerGroup:GetPlayerName().." has successfully inserted "..numofTroops.." troops into battle. Excellent work!",16,"HQ"):ToAll()
                
                TheFrat.SetMooseClientStateData(PlayerGroup,"hasAssignment", false)
                --BriefingMenuCommand:Remove()
                BriefingMenu:Remove()
                
                local missionMarkerText = "Mission ID: "..Task_ID.." - Insertion\n"..
                                        "Pilot: "..PlayerGroup:GetPlayerName().."\n"..
                                        numofTroops.." troops inserted into battle."
                TheFrat.CreateMarker(Zone,missionMarkerText,true)
                
                local MarkerText = "Mission ID: "..Task_ID.." - Insertion\\n"..
                                        "Pilot: "..PlayerGroup:GetPlayerName().."\\n"..
                                        numofTroops.." troops inserted into battle."
                --TheFrat.AddMarkerTable(Zone,Task_ID,MarkerText,TheFrat.GetMooseClientStateData(PlayerGroup,"ucid"))
                
              end, {},5)
            
          end --end if
          
      end--EVENTS.Land
      
      --PlayerLeaveUnit
      PlayerGroup:HandleEvent(EVENTS.PlayerLeaveUnit)
      function PlayerGroup:OnEventPlayerLeaveUnit(EventData)
        
        if missionCompleted == false then
          TheFrat.StopBeacon(beaconID,RadioFreq)
          popFlare:Stop()
          TheFrat.DestroyGroupSet(EnemyGroupSet)
          BriefingMenu:Remove()

        end
        
      end--end EVENTS.PlayerLeaveUnit
      
      --Player DEAD
      PlayerGroup:HandleEvent(EVENTS.Dead)
      function PlayerGroup:OnEventDead(EventData)
         if missionCompleted == false then
          TheFrat.StopBeacon(beaconID,RadioFreq)
          popFlare:Stop()
          TheFrat.DestroyGroupSet(EnemyGroupSet)
          BriefingMenu:Remove()

        end
        
      end--end EVENTS.DEAD
      
      --Pilot Crash
      PlayerGroup:HandleEvent(EVENTS.Crash)
      function PlayerGroup:OnEventCrash(EventData)
        if missionCompleted == false then
          TheFrat.StopBeacon(beaconID,RadioFreq)
          popFlare:Stop()
          TheFrat.DestroyGroupSet(EnemyGroupSet)
          BriefingMenu:Remove()

        end
      end
      

    else
      --no avalible zones or radio freqs
      TheFrat.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
      MESSAGE:New("Currently no Troop Insertion Assingments at this time, please try back later.",10):ToGroup(PlayerGroup)
    end
    
  end
  
end

function TroopInsertion:Menu(playerGroup)
  local PlayerGroup = playerGroup
  local PlayerGroupName = PlayerGroup:GetName()
  --Setup Menu Option
  local function ShowInst()
      local inst = "++ Troop Insertion Instructions ++"
      TheFrat.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
      MESSAGE:New(inst,10):ToGroup(PlayerGroup)
    end
  local function GetAssignment()
    TheFrat.PlaySoundToGroup("beep1.ogg",PlayerGroup)
    MESSAGE:New(">> Fetching Troop Insert Assigment for "..PlayerGroupName,5):ToGroup(PlayerGroup)
    SCHEDULER:New( nil,
      function()
        TheFrat.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
        TroopInsertion:New(PlayerGroup)
      end, {},6)
    
  end
  
  if TheFrat.ClientInTable(Settings.clientTransportsTable,PlayerGroupName) then
    local TroopInsertionMenu = MENU_GROUP:New( PlayerGroup, "Troop Transport" )
    --local TIInstrustions = MENU_GROUP_COMMAND:New( PlayerGroup, "Instructions", TroopInsertionMenu, ShowInst , PlayerGroup )--instr in CSAR class
    local GetTIAssignment = MENU_GROUP_COMMAND:New( PlayerGroup, "Get Troop Insert Assignment", TroopInsertionMenu, GetAssignment , PlayerGroup )
  end
end

TroopInsertion.EnemyTroopSpawn = SPAWN:New(TroopInsertion.Settings.EnemySoliderSpawnGroupName)
     --:InitRandomizeZones({Zone})
     :OnSpawnGroup(
      function( SpawnGroup )
        SpawnGroup:HandleEvent(EVENTS.Birth)
        function SpawnGroup:OnEventBirth(EventData)
          
        end
        SpawnGroup:HandleEvent(EVENTS.Dead)
        function SpawnGroup:OnEventDead(EventData)
          
        end
      end
      )
      --:InitLimit(4,4)
      :InitHeading(0,359)
      --:InitRandomizePosition( true , 600, 350 )
      --:SpawnScheduled(0.5,0)

function TroopInsertion.SpawnEnemyTroopsAtWP(num)
        
end

TroopInsertion.EnemyTroopSpawnRandomizePosition = SPAWN:New(TroopInsertion.Settings.EnemySoliderSpawnGroupName)
     :OnSpawnGroup(
      function( SpawnGroup )
        SpawnGroup:HandleEvent(EVENTS.Birth)
        function SpawnGroup:OnEventBirth(EventData)
          
        end
        SpawnGroup:HandleEvent(EVENTS.Dead)
        function SpawnGroup:OnEventDead(EventData)
          
        end
      end
      )
      :InitHeading(0,359)
      :InitRandomizePosition( true , 600, 350 )

      
TroopInsertion.EnemyBTRSpawn = SPAWN:New(TroopInsertion.Settings.EnemyBTRGroupName)
     :OnSpawnGroup(
      function( SpawnGroup )
        SpawnGroup:HandleEvent(EVENTS.Birth)
        function SpawnGroup:OnEventBirth(EventData)
          
        end
        SpawnGroup:HandleEvent(EVENTS.Dead)
        function SpawnGroup:OnEventDead(EventData)
          
        end
      end
      )
      :InitHeading(0,359)
      :InitRandomizePosition( true , 1205, 1200 )

function TroopInsertion.GetBriefing(ZoneName,ranSquad,ranRank,ranName)
  local briefing = ""
  
  briefing = ranRank.." "..ranName.." is currently requesting reinforcement troops. Get those troops over to his location at once and return to FARP Hollywood."

  return briefing
end
